//Fidget Spinner
//by Wrapperup


//projectile


datablock ExplosionData(fidgetExplosion)
{
   //explosionShape = "";
   explosionShape = "./explosionSphere1.dts";
	soundProfile = rocketExplodeSound;

   lifeTimeMS = 350;

   faceViewer     = true;
   explosionScale = "3 3 3";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 10;
   lightEndRadius = 25;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 1";

   damageRadius = 12;
   radiusDamage = 500;

   impulseRadius = 10;
   impulseForce = 6000;
};

AddDamageType("FidgetRadius",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',1,0);
AddDamageType("FidgetDirect",   '<bitmap:add-ons/Weapon_FidgetSpinner/CI_spinner> %1',    '%2 <bitmap:add-ons/Weapon_FidgetSpinner/CI_spinner> %1',1,1);
datablock ProjectileData(fidgetSpinnerProjectile)
{
   projectileShapeName = "./spinnerprojectile.dts";
   directDamage        = 10;
   directDamageType = $DamageType::FidgetDirect;

   muzzleVelocity      = 10;
   velInheritFactor    = 1.0;
   
   fidgetSound = fidgetSpinnerWoosh1Sound;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 1.0;

   hasLight    = false;

   uiName = "Fidget Spinner";
};

datablock ProjectileData(fidgetSpinnerProjectileTier1:fidgetSpinnerProjectile)
{
   directDamage        = 30;
   
   fidgetSound = fidgetSpinnerWoosh2Sound;
   
   muzzleVelocity      = 40;
   velInheritFactor    = 1.0;
   
   gravityMod = 0.0;
   
   uiName = "Fidget Spinner Tier 1";
};

datablock ProjectileData(fidgetSpinnerProjectileTier2:fidgetSpinnerProjectile)
{
   directDamage        = 90;
   
   fidgetSound = fidgetSpinnerWoosh3Sound;
   
   muzzleVelocity      = 60;
   velInheritFactor    = 1.0;
   
   gravityMod = 0.0;
   
   uiName = "Fidget Spinner Tier 2";
};

datablock ProjectileData(fidgetSpinnerProjectileTier3:fidgetSpinnerProjectile)
{
   directDamage        = 1000;
   
   fidgetSound = fidgetSpinnerBoomSound;
   
   explosion           = fidgetExplosion;
   
   muzzleVelocity      = 120;
   velInheritFactor    = 1.0;
   
   gravityMod = 0.0;
   
   uiName = "Fidget Spinner Tier 3";
};

datablock AudioProfile(fidgetSpinnerSoundLoop)
{
   filename    = "./spinnerloop.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(fidgetSpinnerEquipSound)
{
   filename    = "./spinnerEquip.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(fidgetSpinnerWoosh1Sound)
{
   filename    = "./woosh1.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(fidgetSpinnerWoosh2Sound)
{
   filename    = "./woosh2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(fidgetSpinnerWoosh3Sound)
{
   filename    = "./woosh3.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(fidgetSpinnerBoomSound)
{
   filename    = "./boom.wav";
   description = AudioDefault3d;
   preload = true;
};


//item itself
datablock ItemData(fidgetSpinnerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./spinner.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	sound = fidgetSpinnerSoundLoop;

	//gui stuff
	uiName = "Fidget Spinner";
	iconName = "./icon_fidgetspinner";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = fidgetSpinnerImage;
	canDrop = true;
};

datablock ShapeBaseImageData(fidgetSpinnerImage)
{
   // Basic Item properties
   shapeFile = "./spinner.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.1 0.18";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = fidgetSpinnerItem;
   ammo = " ";
   projectile = fidgetSpinnerProjectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";
   
   // Let there be light - NoLight, ConstantLight, PulsingLight, WeaponFireLight.

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.6;
	stateTransitionOnTimeout[0]     = "Ready";
	stateWaitForTimeout[0]		  	= true;
	stateSequence[0] 				= "startspin";
	stateSound[0]			  		= fidgetSpinnerEquipSound;

	stateName[1]                    = "Ready";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateScript[1] 					= "checkTier";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			 	= "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.53;
	stateSound[2]					= fidgetSpinnerSoundLoop;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = true;
	stateSequence[2]                = "fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]                    = "Fire2";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.53;
	stateSound[3]					= fidgetSpinnerSoundLoop;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = true;
	stateSequence[3]                = "fire";
	stateScript[3]                  = "onFireTwo";
	stateWaitForTimeout[3]			= true;

	stateName[4]					= "Reload";
	stateTimeoutValue[4]			= 0;
	stateTransitionOnTriggerUp[4] = "ready";
	stateTransitionOnTimeout[4]	= 	"Fire2";
};

datablock ShapeBaseImageData(fidgetSpinnerTier1Image:fidgetSpinnerImage)
{
	// Basic Item properties
   shapeFile = "./spinner.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0.1 0.18";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = fidgetSpinnerItem;
   ammo = " ";
   projectile = fidgetSpinnerProjectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";
   
   // Let there be light - NoLight, ConstantLight, PulsingLight, WeaponFireLight.

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

	
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0;
	stateTransitionOnTimeout[0]     = "Fire";
	stateWaitForTimeout[0]		  	= true;
	stateSound[0]			  		= "";

	stateName[1]                    = "Ready";
	stateTransitionOnTimeout[1]     = "Fire";
	stateTimeoutValue[1]            = 0;
	stateScript[1] 					= "checkTier";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			 	= "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.26;
	stateSound[2]					= fidgetSpinnerSoundLoop;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = true;
	stateSequence[2]                = "fire2";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;

	stateName[3]                    = "Fire2";
	stateTransitionOnTimeout[3]     = "Reload";
	stateTimeoutValue[3]            = 0.26;
	stateSound[3]					= fidgetSpinnerSoundLoop;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = true;
	stateSequence[3]                = "fire2";
	stateScript[3]                  = "onFireTwo";
	stateWaitForTimeout[3]			= true;

	stateName[4]					= "Reload";
	stateTimeoutValue[4]			= 0;
	stateTransitionOnTriggerUp[4] = "ready";
	stateTransitionOnTimeout[4]	= 	"Fire2";
};

datablock ShapeBaseImageData(fidgetSpinnerTier2Image:fidgetSpinnerTier1Image){
	projectile = fidgetSpinnerProjectileTier2;

   stateSequence[2]                = "fire3";
   stateSequence[3]                = "fire3";
   
   stateTimeoutValue[2]            = 0.14;
   stateTimeoutValue[3]            = 0.14;
};

datablock ShapeBaseImageData(fidgetSpinnerTier3Image:fidgetSpinnerTier1Image)
{
	projectile = fidgetSpinnerProjectileTier3;

   stateSequence[2]                = "fire4";
   stateSequence[3]                = "fire4";
   
   stateTimeoutValue[2]            = 0.07;
   stateTimeoutValue[3]            = 0.07;
};

function fidgetSpinnerImage::onFire(%this, %obj, %slot)
{
	%obj.spinningTime = $Sim::Time;
}

function fidgetSpinnerTier1Image::onFire(%this,%obj,%slot)
{
	fidgetSpinnerImage::onFire(%this, %obj, %slot);
}

function fidgetSpinnerTier2Image::onFire(%this,%obj,%slot)
{
	fidgetSpinnerImage::onFire(%this, %obj, %slot);
}

function fidgetSpinnerTier3Image::onFire(%this,%obj,%slot)
{
	fidgetSpinnerImage::onFire(%this, %obj, %slot);
}



function fidgetSpinnerImage::onFireTwo(%this,%obj,%slot)
{
	%obj.spinning = true;
	if(($Sim::Time - %obj.spinningTime) > (3 * ((%obj.spinTier+1)/2)))
	{
		if(%obj.tool[%obj.currTool] == nameToID(friendlyFidgetSpinnerItem))
		{
			if(%obj.spinTier < 2)
			{
				%obj.spinTier++;
				fidget_nextTier(%obj);
			}
		}
		else
		{
			if(%obj.spinTier < 3)
			{
				%obj.spinTier++;
				fidget_nextTier(%obj);
			}
		}
	}
}

function fidgetSpinnerTier1Image::onFireTwo(%this,%obj,%slot)
{
	fidgetSpinnerImage::onFireTwo(%this, %obj, %slot);
}

function fidgetSpinnerTier2Image::onFireTwo(%this,%obj,%slot)
{
	fidgetSpinnerImage::onFireTwo(%this, %obj, %slot);
}

function fidgetSpinnerTier3Image::onFireTwo(%this,%obj,%slot)
{
	fidgetSpinnerImage::onFireTwo(%this, %obj, %slot);
}



function fidgetSpinnerImage::checkTier(%this,%obj,%slot)
{
	fidget_checkTier(%obj);
}

function fidgetSpinnerTier1Image::checkTier(%this,%obj,%slot)
{
	fidget_checkTier(%obj);
}

function fidgetSpinnerTier2Image::checkTier(%this,%obj,%slot)
{
	fidget_checkTier(%obj);
}

function fidgetSpinnerTier3Image::checkTier(%this,%obj,%slot)
{
	fidget_checkTier(%obj);
}

function fidget_checkTier(%player)
{
	%player.spinningTime = $Sim::Time;
	
	if(%player.spinTier > 0)
	{
		%player.mountImage(fidgetSpinnerImage, 0);
	}
	%obj.spinning = false;
	%player.spinTier = 0;
}

function fidget_validMount(%player)
{
	if(%player.tool[%player.currTool] == nameToID(friendlyFidgetSpinnerItem))
		return false;

	if(%player.getMountedImage(0) == nametoID(fidgetSpinnerImage))
		return true;
		
	if(%player.getMountedImage(0) == nametoID(fidgetSpinnerTier1Image))
		return true;
		
	if(%player.getMountedImage(0) == nametoID(fidgetSpinnerTier2Image))
		return true;
		
	if(%player.getMountedImage(0) == nametoID(fidgetSpinnerTier3Image))
		return true;
		
	return false;
}

function fidget_nextTier(%player)
{
	%player.mountImage(nameToID("fidgetSpinnerTier" @ %player.spinTier @ "Image"), 0);
}

package FidgetSpinnerPackage
{
	function Armor::onTrigger(%this,%player,%slot,%trigger)
	{
		if(%slot !$= "4" || !fidget_validMount(%player))
		{
			Parent::onTrigger(%this,%player,%slot,%trigger);
			return;
		}
		
		
		if(($Sim::Time - %player.fidgetSpinnerEnable) > 1)
		{
			%player.fidgetSpinnerEnable = $Sim::Time;
			
			//%player.setImageTrigger(0,1);
			
			%vector = %player.getMuzzleVector(0);
			
			if(%player.spinTier > 0)
				%projectile = nameToID("fidgetSpinnerProjectileTier" @ %player.spinTier);
			else
				%projectile = fidgetSpinnerProjectile;
			
			%objectVelocity = %player.getVelocity();
			%vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			
			if(isObject(%projectile.fidgetSound))
				%player.playAudio(0, %projectile.fidgetSound);
			
			%p = new Projectile()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %player.getMuzzlePoint(0);
				originPoint = %player.getMuzzlePoint(0);
				sourceObject = %player;
				sourceSlot = %slot;
				client = %player.client;
			};
			
			fidget_checkTier(%player);
			%player.playthread(2, "shiftUp");
		}
	}

	 function serverCmdDropTool(%client, %slot)
	 {
		if(%client.player.tool[%slot] == nameToID(friendlyFidgetSpinnerItem) || %client.player.tool[%slot] == nameToID(fidgetSpinnerItem))
		{
			if(%client.player.spinTier > 0)
				return false;
		}	
		return Parent::serverCmdDropTool(%client, %slot);
	 }
 };
 activatePackage(FidgetSpinnerPackage);
 
 
 //the friendly fidgit spinner
 
 datablock ItemData(friendlyFidgetSpinnerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./spinner.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	sound = fidgetSpinnerSoundLoop;

	//gui stuff
	uiName = "Harmless Fidget Spinner";
	iconName = "./icon_fidgetspinnerhml";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = fidgetSpinnerImage;
	canDrop = true;
};